package selectedClasses;

/**
 *
 * @author Lefteris Moussiades
 */
public class Strings {

    static void equality1() {
        String s = "Lefteris", newS = "Lefteris",
                s1 = new String("Lefteris");
        System.out.println("s=\"Lefteris\""); //java escape sequences
        System.out.println("newS=\"Lefteris\"");
        System.out.println("s1=new String(\"Lefteris\")");
        System.out.println();
        System.out.println("(s==newS)+\" \"+(s==s1) is " + (s == newS) + " " + (s == s1));
        System.out.println("s.equals(newS)+ \" \"+s.equals(s1) is " + s.equals(newS) + " " + s.equals(s1));
    }

    static void equality2() {
        String s = "Lefteris",
                s1 = new String("LEfteRis");
        System.out.println("s=\"Lefteris\"");
        System.out.println("s1=new String(\"LEfteRis\");");
        System.out.println("s.equals(s1) is " + s.equals(s1));
        System.out.println("s.compareTo(s1) is " + s.compareTo(s1));
        System.out.println("s.compareToIgnoreCase(s1) is " + s.compareToIgnoreCase(s1));
        char e = 'e', E = 'E';
        System.out.println("e-E is " + (e - E));
    }

    static void immutability() {
        String s = "Hello ";
        s.concat("World!");

        System.out.println("String s=\"Hello \";");
        System.out.println("s.concat(\"World!\");");
        System.out.println("s= " + s);

        s = s.concat("World!");
        System.out.println("s=s.concat(\"World!\");");
        System.out.println("s= " + s);
    }

    static void variousFunctions() {
        String s = "Hello World";
        System.out.println("String s=\"Hello World\";");

        int idx = s.indexOf("World");
        System.out.println("s.indexOf(\"World\") is " + s.indexOf("World"));

        String w = s.substring(idx, 9);
        System.out.println("s.substring(idx,9) is " + s.substring(idx, 9));

        boolean b = s.startsWith("He");
        System.out.println("s.startsWith(\"He\") is " + s.startsWith("He"));

        System.out.println("s.toUpperCase() is " + s.toUpperCase());

        s = "    Hello   ";
        System.out.println("s=\"    Hello   \"");
        System.out.println("s.length() is " + s.length());

        System.out.println("s.trim().length()" + s.trim().length());

        s = String.valueOf(256.87);
        System.out.println("s=String.valueOf(256.87);");
        System.out.println("s is " + s);
    }

    static void arraysOfStrings() {
        String[] myA = {
            "aaa",
            "bbb",
            "abcd"
        };
        for (String s:myA)
            System.out.println(s);
    }

    public static void main(String[] args) {
        //equality1();
        equality2();
        //immutability();
        //variousFunctions();
        //arraysOfStrings();
    }
}
